import 'package:freezed_annotation/freezed_annotation.dart';

import '../loading_more_list_library_fast.dart';


part 'status.freezed.dart';

///状态
@freezed
class IndicatorStatusModel with _$IndicatorStatusModel {
  const IndicatorStatusModel._();

  factory IndicatorStatusModel.none() = IndicatorStatusModelWithNone;

  factory IndicatorStatusModel.empty() = IndicatorStatusModelWithEmpty;

  factory IndicatorStatusModel.loadingMoreBusying() =
      IndicatorStatusModelWithLoadingMoreBusying;

  factory IndicatorStatusModel.fullScreenBusying() =
      IndicatorStatusModelWithFullScreenBusying;

  factory IndicatorStatusModel.error(
      {@JsonKey(
          fromJson: null,
          toJson: null,
          includeToJson: false,
          includeFromJson: false)
      Object? error,
      @JsonKey(
          fromJson: null,
          toJson: null,
          includeToJson: false,
          includeFromJson: false)
      StackTrace? stackTrace,
        @JsonKey(
            fromJson: null,
            toJson: null,
            includeToJson: false,
            includeFromJson: false) required RefreshBase refreshBase
      }) = IndicatorStatusModelWithError;

  factory IndicatorStatusModel.fullScreenError(
      {@JsonKey(
          fromJson: null,
          toJson: null,
          includeToJson: false,
          includeFromJson: false)
      Object? error,
      @JsonKey(
          fromJson: null,
          toJson: null,
          includeToJson: false,
          includeFromJson: false)
      StackTrace? stackTrace,
        @JsonKey(
            fromJson: null,
            toJson: null,
            includeToJson: false,
            includeFromJson: false) required RefreshBase refreshBase}) = IndicatorStatusModelWithFullScreenError;

  factory IndicatorStatusModel.noMoreLoad() =
      IndicatorStatusModelWithNoMoreLoad;


}
